<template>
	<v-container>
		<p class="display-1 text-center">Becas para el periodo {{period}}</p>
		<v-snackbar
			v-model="snack"
			color="orange"
			top
			:timeout="timeout"
			v-if="days > 0"
		>Quedan {{days}} días para cierre de convocatoria</v-snackbar>
		<v-snackbar
			v-model="snackClose"
			color="blue"
			top
			:timeout="timeout"
			v-else
		>Convocatoria {{period}} cerrada</v-snackbar>

		<TypesScholarships />
		<StepperForms :displayStepper="complete" />
		<Navigation />
	</v-container>
</template>

<script>
import StepperForms from "@/components/student/StepperForms";
import TypesScholarships from "@/components/student/TypesScholarships";
import Navigation from "@/components/Navigation";
import gql from "graphql-tag";
import { mapState, mapMutations, mapActions } from "vuex";
import EventBus from "../../bus";

export default {
	name: "AvailableScolarships",
	components: {
		Navigation,
		StepperForms,
		TypesScholarships
	},
	data: () => ({
		date: new Date(),
		snackClose: true,
		snack: true,
		days: 20,
		timeout: 3000
	}),
	computed: {
		...mapState(["userData", "complete"]),
		// Muestra el perdiodo actual
		period() {
			if (this.date.getMonth() + 1 <= 6) {
				return `Enero - Junio ${this.date.getFullYear()}`;
			} else {
				return `Agosto - Diciembre ${this.date.getFullYear()}`;
			}
		}
	},
	methods: {
		...mapMutations(["saveUserData", "changeStepper", "setLimitDay"]),
		...mapActions(["getMessages"]),
		// Obtiene datos para condicionar los forms de información del usuario
		async getData() {
			try {
				const { data } = await this.$apollo.query({
					query: gql`
						query($curp: String!) {
							findStudent(curp: $curp) {
								scholarData {
									semester
								}
							}
						}
					`,
					variables: {
						curp: this.userData.curp
					}
				});
				// Condiciona los forms para visualizarlos o no
				data.findStudent.scholarData === null
					? this.changeStepper(true)
					: this.changeStepper(false);
			} catch (error) {}
		},
		// Obtiene la fecha en que cierra la convocatoria
		async getLimitDate() {
			try {
				const { data } = await this.$apollo.query({
					query: gql`
						query {
							getLimitDate
						}
					`
				});
				const currentDate = `${this.date.getFullYear()}-${this.date.getMonth() +
					1}-${this.date.getDate()}`;
				const init = new Date(currentDate).getTime();
				const end = new Date(data.getLimitDate).getTime();
				const diff = end - init;
				const diffDays = diff / (1000 * 60 * 60 * 24);
				const intDays = Math.round(diffDays);
				this.days = intDays;
				this.setLimitDay(this.days);
			} catch (error) {}
		}
	},
	created() {
		this.saveUserData();
		this.getData();
		this.getLimitDate();
		this.getMessages();
	},
	mounted() {
		// cierra el stepper
		EventBus.$on("closeStepper", () => {
			this.changeStepper(false);
		});
	}
};
</script>
